'''

    Replace all hardcoded values used in more than one place throught the project with 
    variables defined here, even the ones found in the hand crafted config.json

'''

ALLOWED_EXTENSIONS = ['.jpg', '.JPG', '.jpeg', '.JPEG', '.png', '.PNG'] 

BUTS_DIR_NAME = 'BUTS'

JSON_ANNOTATIO_DIR = 'ForTrainingAnnotations'

TFR_IMPLICIT_DIR_NAME = 'TFRECORDS_DATASET'

# Utility MODEs and TASKs

TRAIN = 'TRAIN'
PREDICT = 'PREDICT'
EXPORT = 'EXPORT'

CLS = 'CLS'
DTT = 'DTT'

INPUT_OP_NAME = 'input'
OUTPUT_OP_NAME = 'prediction'

# Sample dir expected content

MODEL_FILE_NAME = 'model.py'
CONFIG_FILE_NAME = 'config.json'

# TFR feature keys for serialization

TFR_SAMPLE_NAME = 'sample'
TFR_GROUND_THRUTH_NAME = 'ground_thruth'

# TFR dir expected content

TRAIN_TFR_NAME = 'TRAIN.tfr'
EVAL_TFR_NAME = 'EVALUATION.tfr'
METADATA_FILE_NAME = 'metadata.json'

# TFR dataset metadata json keys

IMAGE_W = 'IMAGE_W'
IMAGE_H = 'IMAGE_H'
COLOR = 'COLOR'
NUM_CLASSES = 'NUM_CLASSES'
NUM_TRAIN_EXAMPLES = 'NUM_TRAIN_EXAMPLES'
NUM_EVAL_EXAMPLES = 'NUM_EVAL_EXAMPLES'
DARKNET_DS_FLAG = 'DARKNET_DS_FLAG'
TF_VERSION = 'TF_VERSION'
CLASS_NAMES = 'CLASS_NAMES'

# ARG PARSER min max ranges

TRAIN_DS_PERCENT_MIN = 0.1
TRAIN_DS_PERCENT_MAX = 0.99

MEM_THRESHOLD_PERCENT_MIN = 0
MEM_THRESHOLD_PERCENT_MAX = 90.

# ARG PARSER STRING OP ARGUMENT KEYWORDS, ignore the grouping, it's just random, 3 on each row 

MODE_ARG = 'mode'

SRC_DIR_ARG, DST_DIR_ARG, PLATTEAU_TOLERANCE_ARG = ['pred_src_dir', 'pred_dst_dir',  'platteau_tolerance' ]
TASK_ARG, CONFIG_ARG, DUMP_ARG = [ 'task', 'config', 'dump' ]
IMG_DATASET_ARG, COLOR_ARG, EXTENSION_ARG = ['img_dataset', 'color', 'extension']
PERCENT_ARG, THRESHOLD_ARG, TFR_DATASET_ARG = ['percent', 'threshold', 'tfr_dataset']
CHECKPOINT_DIR_ARG, EXPORT_MODEL_DIR_ARG, EXPORT_MODEL_FILE_NAME_ARG = ['checkpoints_dir', 'export_model_dir', 'export_model_file_name']